Skip to main content
`Ctrl`+`K`

# PEPSetWhichEigenpairs

Specifies which portion of the spectrum is to be sought.

## Synopsis

    #include "slepcpep.h"
    PetscErrorCode PEPSetWhichEigenpairs(PEP pep,PEPWhich which)

Logically Collective

## Input Parameters

- pep - the polynomial eigensolver context

- which - the portion of the spectrum to be sought, see `PEPWhich` for possible values

## Options Database Keys

- -pep_largest_magnitude - sets largest eigenvalues in magnitude

- -pep_smallest_magnitude - sets smallest eigenvalues in magnitude

- -pep_largest_real - sets largest real parts

- -pep_smallest_real - sets smallest real parts

- -pep_largest_imaginary - sets largest imaginary parts

- -pep_smallest_imaginary - sets smallest imaginary parts

- -pep_target_magnitude - sets eigenvalues closest to target

- -pep_target_real - sets real parts closest to target

- -pep_target_imaginary - sets imaginary parts closest to target

- -pep_all - sets all eigenvalues in an interval or region

## Notes

Not all eigensolvers implemented in `PEP` account for all the possible values of `which`. Also, some values make sense only for certain types of problems. If SLEPc is compiled for real numbers `PEP_LARGEST_IMAGINARY` and `PEP_SMALLEST_IMAGINARY` use the absolute value of the imaginary part for eigenvalue selection.

The target is a scalar value provided with `PEPSetTarget()`.

The criterion `PEP_TARGET_IMAGINARY` is available only in case PETSc and SLEPc have been built with complex scalars.

`PEP_ALL` is intended for use in combination with an interval (see `PEPSetInterval()`), when all eigenvalues within the interval are requested, and also for computing all eigenvalues in a region with the `PEPCISS` solver.

## See Also

PEP: Polynomial Eigenvalue Problems, `PEPGetWhichEigenpairs()`, `PEPSetTarget()`, `PEPSetInterval()`, `PEPSetDimensions()`, `PEPSetEigenvalueComparison()`, `PEPWhich`

## Level

intermediate

## Location

src/pep/interface/pepopts.c

## Examples

src/pep/tutorials/ex50.c
src/pep/tutorials/ex38.c

Index of all PEP routines Table of Contents for all manual pages Index of all manual pages